;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_ZEIGER_UND_FEHLER_ANZEIGEN:
	LDS temp1,(adr_DCF_ZEIGER)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_DIGIT_0),temp1
	STS (adr_LED_DIGIT_1),temp2
	STS (adr_LED_DIGIT_2),VOLL

	LDS temp1,(adr_DCF_ANZAHL_FEHLER)		; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_DIGIT_3),temp1
	STS (adr_LED_DIGIT_4),temp2
	STS (adr_LED_DIGIT_5),temp3

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
IMPULSLAENGE_ANZEIGEN:
	LDS temp1,(adr_DCF_IMPULSLAENGE_AUS)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_DIGIT_0),temp1
	STS (adr_LED_DIGIT_1),temp2
	STS (adr_LED_DIGIT_2),temp3
	STS (adr_LED_DIGIT_3),VOLL
	STS (adr_LED_DIGIT_4),VOLL
	STS (adr_LED_DIGIT_5),VOLL
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
ZEIT_ANZEIGEN:
	; SEKUNDEN	
	LDS temp1,(adr_ss)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_DIGIT_0),temp1
	STS (adr_LED_DIGIT_1),temp2
	; Minuten	
	LDS temp1,(adr_mm)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	andi temp1,0b01111111		; PUNKT	
	STS (adr_LED_DIGIT_2),temp1
	STS (adr_LED_DIGIT_3),temp2
	; Stunden	
	LDS temp1,(adr_hh)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	andi temp1,0b01111111		; PUNKT	
	STS (adr_LED_DIGIT_4),temp1
	STS (adr_LED_DIGIT_5),temp2
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DATUM_ANZEIGEN:
	; JAHR		
	LDS temp1,(adr_JAHR)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_DIGIT_0),temp1
	STS (adr_LED_DIGIT_1),temp2
	; Monat		
	LDS temp1,(adr_MONAT)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	andi temp1,0b01111111		; PUNKT	
	STS (adr_LED_DIGIT_2),temp1
	STS (adr_LED_DIGIT_3),temp2
	; TAG		
	LDS temp1,(adr_TAG)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	andi temp1,0b01111111		; PUNKT	
	STS (adr_LED_DIGIT_4),temp1
	STS (adr_LED_DIGIT_5),temp2

ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
WOCHENTAG_ANZEIGEN:
	LDS temp1,(adr_WOCHENTAG)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
	STS (adr_LED_DIGIT_0),temp1
	STS (adr_LED_DIGIT_1),temp2
	STS (adr_LED_DIGIT_2),VOLL
	STS (adr_LED_DIGIT_3),VOLL
	STS (adr_LED_DIGIT_4),VOLL
	STS (adr_LED_DIGIT_5),VOLL
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
WERT_ANZEIGEN_POSITIV_32:
	LDS temp1,(adr_DCF_IMPULSLAENGE_AN)			; aus SRAM laden	
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8
;-- NULLSTELLEN_UNTERDRCKUNG -----------------------------------------
	; DIGIT-5					
	cpi temp6,0b11000000		; vergleich "0"	
	brne WERT_ANZEIGEN_DIGIT	; Sprung		
	ldi temp6,0b11111111		; aus !			
	; DIGIT-4					
	cpi temp5,0b11000000		; vergleich "0"	
	brne WERT_ANZEIGEN_DIGIT	; Sprung		
	ldi temp5,0b11111111		; aus !			
	; DIGIT-3					
	cpi temp4,0b11000000		; vergleich "0"	
	brne WERT_ANZEIGEN_DIGIT	; Sprung		
	ldi temp4,0b11111111		; aus !			
	; DIGIT-2					
	cpi temp3,0b11000000		; vergleich "0"	
	brne WERT_ANZEIGEN_DIGIT	; Sprung		
	ldi temp3,0b11111111		; aus !			
	; DIGIT-1					
	cpi temp2,0b11000000		; vergleich "0"	
	brne WERT_ANZEIGEN_DIGIT	; Sprung		
	ldi temp2,0b11111111		; aus !			
	; DIGIT-0					
	cpi temp1,0b11000000		; vergleich "0"	
	brne WERT_ANZEIGEN_DIGIT	; Sprung		
	ldi temp1,0b10111111		; aus !			
; ----------------------------------------------------------------------
WERT_ANZEIGEN_DIGIT:
	STS (adr_LED_DIGIT_0),temp1
	STS (adr_LED_DIGIT_1),temp2
	STS (adr_LED_DIGIT_2),temp3
	STS (adr_LED_DIGIT_3),temp4
	STS (adr_LED_DIGIT_4),temp5
	STS (adr_LED_DIGIT_5),temp6
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;																			
;	Value: 0...	99.999.999													
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		   1-er Stelle)									
;			temp2	(		  10-er Stelle)									
;			temp3	(        100-er Stelle)									
;			temp4	(      1.000-er Stelle)									
;			temp5	(     10.000-er Stelle)									
;			temp6	(    100.000-er Stelle)									
;			temp7	(  1.000.000-er Stelle)									
;			temp8	( 10.000.000-er Stelle)									
; 																			
; rcall FUNKTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...8			
; 																			
FUNKTION_HEX_ASC_32:
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)

; Umwandlung auf 7 Segment	
	mov temp,temp1				; temp1			
	rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp	
	mov temp1,temp
	mov temp,temp2				; temp2			
	rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp	
	mov temp2,temp
	mov temp,temp3				; temp3			
	rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp	
	mov temp3,temp
	mov temp,temp4				; temp4			
	rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp	
	mov temp4,temp
	mov temp,temp5				; temp5			
	rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp	
	mov temp5,temp
	mov temp,temp6				; temp6			
	rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp	
	mov temp6,temp
	mov temp,temp7				; temp7			
	rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp	
	mov temp7,temp
	mov temp,temp8				; temp8			
	rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp	
	mov temp8,temp

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT/OUTPUT: TEMP													  		
; rcall UMWANDLUNG_7_SEGMENT 	; inp/out: temp									
UMWANDLUNG_7_SEGMENT:
	cpi temp,'0'
	breq UMWANDLUNG_7_SEGMENT_0
	cpi temp,'1'
	breq UMWANDLUNG_7_SEGMENT_1
	cpi temp,'2'
	breq UMWANDLUNG_7_SEGMENT_2
	cpi temp,'3'
	breq UMWANDLUNG_7_SEGMENT_3
	cpi temp,'4'
	breq UMWANDLUNG_7_SEGMENT_4
	cpi temp,'5'
	breq UMWANDLUNG_7_SEGMENT_5
	cpi temp,'6'
	breq UMWANDLUNG_7_SEGMENT_6
	cpi temp,'7'
	breq UMWANDLUNG_7_SEGMENT_7
	cpi temp,'8'
	breq UMWANDLUNG_7_SEGMENT_8
	cpi temp,'9'
	breq UMWANDLUNG_7_SEGMENT_9

	; AUS	
	cpi temp,0
	breq UMWANDLUNG_7_SEGMENT_AUS
	; MINUS	
	cpi temp,'-'
	breq UMWANDLUNG_7_SEGMENT_MINUS

	cpi temp,'H'
	breq UMWANDLUNG_7_SEGMENT_H
	cpi temp,'E'
	breq UMWANDLUNG_7_SEGMENT_E
	cpi temp,'L'
	breq UMWANDLUNG_7_SEGMENT_L


	; ERROR		
	ldi temp,0b10000110
	ret
UMWANDLUNG_7_SEGMENT_0:	;
	ldi temp,0b11000000
	ret
UMWANDLUNG_7_SEGMENT_1:	;
	ldi temp,0b11111001
	ret
UMWANDLUNG_7_SEGMENT_2:	;
	ldi temp,0b10100100
	ret
UMWANDLUNG_7_SEGMENT_3:	;
	ldi temp,0b10110000
	ret
UMWANDLUNG_7_SEGMENT_4:	;
	ldi temp,0b10011001
	ret
UMWANDLUNG_7_SEGMENT_5:	;
	ldi temp,0b10010010
	ret
UMWANDLUNG_7_SEGMENT_6:	;
	ldi temp,0b10000010
	ret
UMWANDLUNG_7_SEGMENT_7:	;
	ldi temp,0b11111000
	ret
UMWANDLUNG_7_SEGMENT_8:	;
	ldi temp,0b10000000
	ret
UMWANDLUNG_7_SEGMENT_9:	;
	ldi temp,0b10010000
	ret
UMWANDLUNG_7_SEGMENT_AUS:	;
	ldi temp,0b11111111
	ret
UMWANDLUNG_7_SEGMENT_MINUS:	;
	ldi temp,0b10111111
	ret
UMWANDLUNG_7_SEGMENT_H:	;
	ldi temp,0b10001001
	ret
UMWANDLUNG_7_SEGMENT_E:	;
	ldi temp,0b10000110
	ret
UMWANDLUNG_7_SEGMENT_L:	;
	ldi temp,0b11000111
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

